.NET Language Localizator

.NET Language Localizator 2
for .NET 2

Copyright © 1997, 2006 Zbyšek Hlinka

Technical Requirements

Hardware: Processor Pentium or compatible and better; RAM depends on size of project and operating system (recommended at least 512 MB); HDD 20 MB or more (for application and dictionaries); monitor resolution 1024x768 or better; 16bits colors; mouse.
Software: MS Windows 2000 or better; .NET 2 Framework.

System Philosophy

System is primary designed for software developers and companies doing localization of such products. At specific circumstances the system can be suitable also for localization of programs or files for end user personal needs. Language Localizator is modular system, which can be supplemented and extended according to needs.

License Agreement
Language Localizator Conception
Main Program
Dictionaries
Localization of Assemblies

Using strong name signing
Exceptions for localize of .NET 1.1 applications

Localizing your project in the MS Visual Studio 2005 step by step

Prepare your projects in these steps:

  1. Create your application. Open Properties editor, select application tab, press Assembly Information button. In opened dialog select application language in the Neutral Language combo. Choose language, in which you will write your project, or let (None) - in this case will default language as "en". Recommended, you write whole application in one language which you selected in this dialog.

  2. Set Localizable property to true in an every forms in your every localizable project.
  3. Keep Language property to (default) only. If you created some other national forms, remove it.

  4. Make ready your project to language changing (see example project).
  5. Every localizable strings out of forms put into Properties.Resources.resx file. Do not let them in your source code.

  6. Save and build your project(s).
  7. Run .NET Language Localizator.
  8. Select Global Options folder.
  9. Fill out all items, if needed. Auto translate item recommended check in a project options.
  10. Ignored properties - fill out names (or part of names) of properties, which you do not want localize - this properties will not be visible. If Pos=1 is checked, then property name must be identical from first position, else it can be identical from any position.
  11. Designated - here are list of texts, which are not translated, but which are designated as translated.

  12. Open Options / Project Opener Manager and select to top your prefer project type.
  13. Select language from left window. This designates final language version of your translations. For example, your application is originally in English language. If you want create Czech localization, select cs-CZ language.

  14. Press Open new project button (or File / Open Project menu) and open a project.
  15. At first opening you pass through all items and you set every Options for opened project (as Auto translate and Dictionary). Destination directory determine where will place building result (localized file). If you let it empty, destination directory will create automatically as <project path>\<language>.

  16. Open all resources and set Lock to true where you can forbid translation.
  17. In toolbar press Translate all lines button and translate all untranslated lines. Save all changes.
  18. Translate all untranslated lines in whole project. You must open every resource node and translate lines by hand.
  19. You can change other properties including pictures too.
  20. Press Build (Tools / Build) button.

Color legend for translation status (project grids and project tree; in project tree it signalize only string properties status):
Translated text
Text marked like translated
Untranslated text
New untranslated text against previous translation process

Limitation of lite version

You can translate all *.resx and *.resources files without restrictions. If you want translate some assembly (exe, dll), the Language Localizator damage final translation by randomly untranslated resources.

Your translated *.resx or *.resources files you can copy back to project (replace original resources after theirs backup or as language versions, see Custom Culture Technology Sample page in MSDN) and build your project.


Localization of Assemblies

Assembly file is executable file, which has mostly EXE or DLL extension. Significant characteristic for these files is that data part is separated from executive part in specific format. This characteristic can be used with advantage for picking, translating and putting back translated texts without affecting program functionality.

For programmers of applications designated for localization it means that they should attend to appropriate placing of all texts and structures, which should be localized. That is why it is not allowed to write texts directly into executive code of program, but it is always necessary to ensure, that texts will be able to get into the resource table of assembly file. Programmers can solve it by creating all resources in separate (.resx in source code) files, which are compiled and linked into the program. On the other side it means that the texts, which should not be localized should not appear in resource table at all. Nevertheless there are such situations, so Language Localizator offers tools for “securing” such texts from translator.

Destination Files of Localization

Language Localizator can create extern data DLL assembly, which will be used as a resource source by original program. Or you can translate directly resource file (*.resx, *.resources).

IMPORTANT CAUTION: localization DLL assembly have to be created from final compilation of program. Otherwise it is impossible give a warranty.

Localization data DLL assembly are organized so that it is placed in directory of abbreviation of language name, into which was made localization.

Immediately after execution, program written .NET detects Windows language settings and checks subdirectory, if there exists a file with the name equal to the program. If such file is found, its resources are used instead of program resources, otherwise it automatically uses its own resources.

Setting default language or changing language for program
If you want to use other language then the one specified in Windows (for example program is written in English, Windows are set to Czech, you have Czech and German localization, but you want to use German localization), you can inspire at example project files.

Localization Procedure

Before opening localized file set (or create) modules and dictionaries, which you will need for localization, especially if you have several modules for one resource.

After opening localized file set all necessary properties, it means if file should be automatically localized on next opening and fonts of original and localized texts. In case of need create lists of texts, which will be automatically marked as translated, which should be ignored and which should be distinct from others. Further check the whole structure and eventually lock the texts or the whole resources, which should stay without changes. Exclude resources, which should not be stored into localization DLL (when storing translations back into the program it is omitted) and set dictionaries. Save changes and then you can try first manual translation (button for collective translation) for each group of resources separately or close the file and open it again. During this procedure there will be create a directory, which is named by the selected language and where all necessary files for translation will be stored.

What should be given to translator
Result of these settings are files *.store and *.options in localization directory. If the you will give project prepared this way to external translator, you should give him program with all used assemblies, dictionaries, which you use and localize.net.exe.options files from localization directory. Do not give config files, in which are stored last positions of dialogs, to translator. If you want to prohibit him in creating final localization file, you do not have to grand him your license key.

Eventually you can export not translated texts into external file, hand it over for translation and finally import translations into the dictionary.

Dictionary Assigning

For dialog translation or translation of other resources belonging to the particular program use rather your own separated dictionaries. It is transparent and it allows you to change dictionaries specific for every project. Standard dictionary should be used only for such texts, which appear in all your programs. Typically these are texts in referenced standard assemblies.

In the window with resource tree select a resource (object), to which you want to assign its dictionary. By clicking on right mouse button you will display menu with functions, which can be used to assign dictionary bat also to mark the whole resource as translated or you can exclude it from processing (resource will stay in tree and it is only ignored). This can be done for single resources and also for the whole nodes.

Translation
Open the resource, which is not completely translated (it has blue or yellow box), and translate all the texts, which have to be translated, or mark them as translated. Each resource format has different dialog window, which depends on its internal structure. During resource localization follow properties and function of particular module. Some resource objects can contain more complex internal structure (typically Size or Font object). Language Localizator contains modules for standard property structures. If such object can contain another nested object, they can be managed by individual module for their translation. If it happens, that inside of particular object exists another object with specific internal structureand for such format there is no translation module, it is possible to write such module.


Language Localizator Conception

As indicated above, the Language Localizator is universal tool for localization of .NET resources and assemblies.

Main Sections

Localization function. This function manage taking apart, translation and compounding .NET resource format to be equal to original format.

Dictionaries. These assemblies manage saving translated texts and their granting to localization modules, when they ask for text translation. Dictionaries can be built on different platforms, databases and so on. By writing appropriate module it can be possible to use dictionaries from earlier ways of localization or dictionaries from competitive products. Basic dictionary template allows exchanging texts among dictionaries or creating reverse dictionaries.

Exporters/importers. These modules manage text export and import among modules and external formats. For example text file, XML etc… Exported texts can be used for translation by external translator or for transfer among various programs.

Translation exceptions. Sometimes it is necessary to mark particular text as translated, but it must not be translated. This module contains list of such texts.

Ignored properties. Some structures, for example various forms, have properties, which should be hidden from translator. This module contains list of such properties including parameters for their visibility.


Dictionaries

Language Localizator can work with different dictionaries; you can even create your own dictionaries if you have some translation database from earlier time or from other localization programs (you have to know structure of stored texts). Because not all of dictionaries are supposed to have the same functionality, some of their properties do not have to be implemented, next description will be focused on standard dictionary supplied with Localizator.

Dictionary Organization

On the side of original (translating) texts can be generally any language, but the language has to be marked. On this side can be mixture of any language. On the side of translated text can be always only one (target) language, to which you are translating. Dictionary generally has some flag of target language in its name.

You can have more than one dictionary for every language. Sometimes it can be useful to have special dictionaries for different data formats, for example special dictionary for strings, other for dialogs.

Recommendation:
Language flag (abbreviation) is mostly two characters long, but if there are more variants for some language (typically English), there exists two characters long abbreviation to express this group. When you work with dictionaries, it is better to create dictionary for the whole group and for original text marking use two characters long abbreviation, if there are more variants for particular language. By following this rule you can avoid unnecessary problems. That means, that instead of en-AU, en-GB and so on, use better abbreviation en. It concerns also other languages.

Dictionary Opening

In main program choose destination language and open dictionary by using popup menu. From list select desired dictionary. If you want to open dictionary dialog, you can open relevant dialog in the window with dictionaries, using popup menu.

If you would like to select from all available dictionaries, open the dictionary using popup menu in dictionary window.

Notice: If you open a new project, Localizator generally assigns standard dictionary of first dictionary interface. You can change this dictionary before starting translation, if automatically assigned dictionary is not suitable for it. Dictionary opened this way will be automatically closed after closing last project, which uses this dictionary.

New Dictionary Creation

Select appropriate dialog for a new dictionary creation, select target language, choose appropriate interface for dictionary and finally enter the name of the dictionary. The name has to follow rules for selected interface.

Rules For Standard Dictionary Naming
Basic name of dictionary from “Localizator Main Dictionaries Library” interface has following format: LocNet2_<lang>.dictionary, where <lang> is two or five characters long abbreviation of target language (equal to first column in language window, which means the language, the translation is made to). So LocNet2_en.dictionary is common dictionary for all English types, LocNet2_fr-BE is the dictionary for Belgian French etc. User dictionaries have format <name>LocNet2_<lang>.trn, where <name> is any name defined by user.

Notice: If you open a new project in a new language, a standard dictionary will be automatically created.

Localizator Main Dictionaries Library

Dictionary has following basic elements: lock, flag of original text language, original text and translated text. If text is locked, it will not be used for automatic translation. Each text can have one or more translations. This function is useful in case, when one expression in source language has several meanings in target language. For example name of the month “May”, which in English is the same for the whole name of the month and also for three characters long abbreviation. Languages, whose months names are not derived from Latin or use more characters for its name, will have at least two expressions in translation – one three characters long and second for month full name. For automatic translation will be used primary marked translation. Text with more translations has highlighted background. Marking of original language is useful for making reverse dictionaries.

Text Translation
In editing dialog, in the grid title is original text and in single rows is list of translations. In column Default is marked which translation should be used as default for automatic translation.

Text translation is made in grid cell. Before saving translation into dictionary check, if source language is set correctly.

If you need to correct original text for some reason, double click left mouse button. After making changes in editor, save new version by pressing OK button. Use this function in case you will manually enter new text with translations to dictionary.

In future:

Reverse Dictionary Creation
This function allows creating inverted text translations. That means that it makes original texts from translated and translated texts from original. During the conversion are converted only texts, whose original language mark is equal to target dictionary language. Translation from original dictionary is marked as original text in target dictionary and its language is equal to original dictionary language.

Procedure:
Open dictionary you want to create reverse dictionary. Select reverse dictionary function from tools menu, select (or create) target dictionary, which respond to language you want to convert into. Target dictionary can already exist and it can be filled also. Only texts, which are not yet in target dictionary or translation is not equal (translation will be inserted as a new line), are converted.

Example:
Open French dictionary LocNet2_fr.trn. Most of original texts are in English (marked as en), dictionary is English-French (for this example). If you wish to create English dictionary, choose LocNet2_en.trn (original texts language has to be equal to target dictionary language). All new texts, which are on the original text position, will be marked as fr and texts on the translation side will be in English after conversion. If there are also other texts then en in French dictionary, these will not be converted.

Dictionary Crossing
Using this function you can create any language combination. For example from English-French and English-Spanish dictionary you can create French-Spanish dictionary. It is necessary to follow these rules:

  • Dictionaries, which are going to be crossed, have to be of different languages.

  • It is supposed, that original texts in both dictionaries are mostly equal, including original text language.

  • Target dictionary, in which you will store crossed translations, has to be in the same language as one of source dictionaries.

Procedure:
Open dictionary, whose translations you want to put in the crossed dictionary as original texts. In Tools menu select dictionary crossing and in dialog select other language dictionary, which has the same set of original texts as opened dictionary (including the same language mark). Further choose (create) dictionary, in which should be stored crossed translations and which is of the same language as previously selected dictionary.

Example:
Open French dictionary, LocNet2_fr.trn. Most of original texts is in English (marked as en), that means that dictionary is English-French (for this example). You want to create French-Spanish dictionary, so select English-Spanish dictionary (LocNet2_es.trn). Create new dictionary (for example) FRLocNet2_es.trn. After conversion, the French texts will be on the original text side and Spanish texts will be on the translated text side. They will be converted using conjunctive English text. The new dictionary can be stored as it is or it can be copied into another appropriate dictionary. It is possible to create reverse dictionary to this dictionary.

Conversion Between Dictionaries
These two functions allow text conversion from other dictionary or exporting translations into another dictionary. Both of the dictionaries have to be of same language. Like in reverse dictionary, you will open the dictionary and choose second dictionary for conversion. This way you can combine different dictionaries of the same language together or convert texts among various dictionary interfaces.

Export To Text File And Import From Text File
These functions allow export into external files and import from these files back into dictionary. Conversion function is managed by interface itself so it is possible to write other interfaces for conversion among different data formats. Except a plain text it is possible to convert translations for example from/into XML format, but it is also possible to convert translation dictionaries from database you have created by earlier ways of translation or from any other dictionary formats, if you can read their structure. This way of data conversion from other dictionaries is more comfortable then creation of dictionary interface for particular database. Only legal users of Language Localizator can have necessary information for creation of their own interfaces.

Dictionary export/import modules

If you want load translations from another datasets, you must have a correspondent export/import module.

Import translations from Microsoft csv glossaries:

  1. Download needed files from ftp://ftp.microsoft.com/developr/msdn/newup/Glossary/
  2. Select a Target language, right click on Dictionaries window and select Open dictionary in the popup menu. Select a dictionary.
  3. Open dictionary form by double click in Dictionaries window.
  4. In the Dictionary form select menu Tools / Import from External Data Source. Select module Localizator Import from MS CSV glossaries, and then a *.csv file.

Required file format:
<original English text>,<accelerator char or blank>,<translation text>,<accelerator char or blank>,<category>,[....]
or
<original English text>;<accelerator char or blank>;<translation text>;<accelerator char or blank>;<category>;[....]
where category values NUM and ACL are not accepted by module.

Examples:
"Import...","I","Importovat...","I",MNU,,Windows,Works,"2000",,,,,,,,,,,,,,
"Category:",,"Kategorie:",,TXB,,Windows,Works,"2000",,,,,,,,,,,,,,

Note: if you create too big dictionary, you will wait a long time for opening of dictionary and translating.


License Agreement

GNU GENERAL PUBLIC LICENSE

Version 2, June 1991

Copyright (C) 1989, 1991 Free Software Foundation, Inc.
51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA

Everyone is permitted to copy and distribute verbatim copies
of this license document, but changing it is not allowed.

Preamble

The licenses for most software are designed to take away your freedom to share and change it. By contrast, the GNU General Public License is intended to guarantee your freedom to share and change free software--to make sure the software is free for all its users. This General Public License applies to most of the Free Software Foundation's software and to any other program whose authors commit to using it. (Some other Free Software Foundation software is covered by the GNU Lesser General Public License instead.) You can apply it to your programs, too.

When we speak of free software, we are referring to freedom, not price. Our General Public Licenses are designed to make sure that you have the freedom to distribute copies of free software (and charge for this service if you wish), that you receive source code or can get it if you want it, that you can change the software or use pieces of it in new free programs; and that you know you can do these things.

To protect your rights, we need to make restrictions that forbid anyone to deny you these rights or to ask you to surrender the rights. These restrictions translate to certain responsibilities for you if you distribute copies of the software, or if you modify it.

For example, if you distribute copies of such a program, whether gratis or for a fee, you must give the recipients all the rights that you have. You must make sure that they, too, receive or can get the source code. And you must show them these terms so they know their rights.

We protect your rights with two steps: (1) copyright the software, and (2) offer you this license which gives you legal permission to copy, distribute and/or modify the software.

Also, for each author's protection and ours, we want to make certain that everyone understands that there is no warranty for this free software. If the software is modified by someone else and passed on, we want its recipients to know that what they have is not the original, so that any problems introduced by others will not reflect on the original authors' reputations.

Finally, any free program is threatened constantly by software patents. We wish to avoid the danger that redistributors of a free program will individually obtain patent licenses, in effect making the program proprietary. To prevent this, we have made it clear that any patent must be licensed for everyone's free use or not licensed at all.

The precise terms and conditions for copying, distribution and modification follow.

TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

0. This License applies to any program or other work which contains a notice placed by the copyright holder saying it may be distributed under the terms of this General Public License. The "Program", below, refers to any such program or work, and a "work based on the Program" means either the Program or any derivative work under copyright law: that is to say, a work containing the Program or a portion of it, either verbatim or with modifications and/or translated into another language. (Hereinafter, translation is included without limitation in the term "modification".) Each licensee is addressed as "you".

Activities other than copying, distribution and modification are not covered by this License; they are outside its scope. The act of running the Program is not restricted, and the output from the Program is covered only if its contents constitute a work based on the Program (independent of having been made by running the Program). Whether that is true depends on what the Program does.

1. You may copy and distribute verbatim copies of the Program's source code as you receive it, in any medium, provided that you conspicuously and appropriately publish on each copy an appropriate copyright notice and disclaimer of warranty; keep intact all the notices that refer to this License and to the absence of any warranty; and give any other recipients of the Program a copy of this License along with the Program.

You may charge a fee for the physical act of transferring a copy, and you may at your option offer warranty protection in exchange for a fee.

2. You may modify your copy or copies of the Program or any portion of it, thus forming a work based on the Program, and copy and distribute such modifications or work under the terms of Section 1 above, provided that you also meet all of these conditions:

a) You must cause the modified files to carry prominent notices stating that you changed the files and the date of any change.
b) You must cause any work that you distribute or publish, that in whole or in part contains or is derived from the Program or any part thereof, to be licensed as a whole at no charge to all third parties under the terms of this License.
c) If the modified program normally reads commands interactively when run, you must cause it, when started running for such interactive use in the most ordinary way, to print or display an announcement including an appropriate copyright notice and a notice that there is no warranty (or else, saying that you provide a warranty) and that users may redistribute the program under these conditions, and telling the user how to view a copy of this License. (Exception: if the Program itself is interactive but does not normally print such an announcement, your work based on the Program is not required to print an announcement.)

These requirements apply to the modified work as a whole. If identifiable sections of that work are not derived from the Program, and can be reasonably considered independent and separate works in themselves, then this License, and its terms, do not apply to those sections when you distribute them as separate works. But when you distribute the same sections as part of a whole which is a work based on the Program, the distribution of the whole must be on the terms of this License, whose permissions for other licensees extend to the entire whole, and thus to each and every part regardless of who wrote it.

Thus, it is not the intent of this section to claim rights or contest your rights to work written entirely by you; rather, the intent is to exercise the right to control the distribution of derivative or collective works based on the Program.

In addition, mere aggregation of another work not based on the Program with the Program (or with a work based on the Program) on a volume of a storage or distribution medium does not bring the other work under the scope of this License.

3. You may copy and distribute the Program (or a work based on it, under Section 2) in object code or executable form under the terms of Sections 1 and 2 above provided that you also do one of the following:

a) Accompany it with the complete corresponding machine-readable source code, which must be distributed under the terms of Sections 1 and 2 above on a medium customarily used for software interchange; or,
b) Accompany it with a written offer, valid for at least three years, to give any third party, for a charge no more than your cost of physically performing source distribution, a complete machine-readable copy of the corresponding source code, to be distributed under the terms of Sections 1 and 2 above on a medium customarily used for software interchange; or,
c) Accompany it with the information you received as to the offer to distribute corresponding source code. (This alternative is allowed only for noncommercial distribution and only if you received the program in object code or executable form with such an offer, in accord with Subsection b above.)

The source code for a work means the preferred form of the work for making modifications to it. For an executable work, complete source code means all the source code for all modules it contains, plus any associated interface definition files, plus the scripts used to control compilation and installation of the executable. However, as a special exception, the source code distributed need not include anything that is normally distributed (in either source or binary form) with the major components (compiler, kernel, and so on) of the operating system on which the executable runs, unless that component itself accompanies the executable.

If distribution of executable or object code is made by offering access to copy from a designated place, then offering equivalent access to copy the source code from the same place counts as distribution of the source code, even though third parties are not compelled to copy the source along with the object code.

4. You may not copy, modify, sublicense, or distribute the Program except as expressly provided under this License. Any attempt otherwise to copy, modify, sublicense or distribute the Program is void, and will automatically terminate your rights under this License. However, parties who have received copies, or rights, from you under this License will not have their licenses terminated so long as such parties remain in full compliance.

5. You are not required to accept this License, since you have not signed it. However, nothing else grants you permission to modify or distribute the Program or its derivative works. These actions are prohibited by law if you do not accept this License. Therefore, by modifying or distributing the Program (or any work based on the Program), you indicate your acceptance of this License to do so, and all its terms and conditions for copying, distributing or modifying the Program or works based on it.

6. Each time you redistribute the Program (or any work based on the Program), the recipient automatically receives a license from the original licensor to copy, distribute or modify the Program subject to these terms and conditions. You may not impose any further restrictions on the recipients' exercise of the rights granted herein. You are not responsible for enforcing compliance by third parties to this License.

7. If, as a consequence of a court judgment or allegation of patent infringement or for any other reason (not limited to patent issues), conditions are imposed on you (whether by court order, agreement or otherwise) that contradict the conditions of this License, they do not excuse you from the conditions of this License. If you cannot distribute so as to satisfy simultaneously your obligations under this License and any other pertinent obligations, then as a consequence you may not distribute the Program at all. For example, if a patent license would not permit royalty-free redistribution of the Program by all those who receive copies directly or indirectly through you, then the only way you could satisfy both it and this License would be to refrain entirely from distribution of the Program.

If any portion of this section is held invalid or unenforceable under any particular circumstance, the balance of the section is intended to apply and the section as a whole is intended to apply in other circumstances.

It is not the purpose of this section to induce you to infringe any patents or other property right claims or to contest validity of any such claims; this section has the sole purpose of protecting the integrity of the free software distribution system, which is implemented by public license practices. Many people have made generous contributions to the wide range of software distributed through that system in reliance on consistent application of that system; it is up to the author/donor to decide if he or she is willing to distribute software through any other system and a licensee cannot impose that choice.

This section is intended to make thoroughly clear what is believed to be a consequence of the rest of this License.

8. If the distribution and/or use of the Program is restricted in certain countries either by patents or by copyrighted interfaces, the original copyright holder who places the Program under this License may add an explicit geographical distribution limitation excluding those countries, so that distribution is permitted only in or among countries not thus excluded. In such case, this License incorporates the limitation as if written in the body of this License.

9. The Free Software Foundation may publish revised and/or new versions of the General Public License from time to time. Such new versions will be similar in spirit to the present version, but may differ in detail to address new problems or concerns.

Each version is given a distinguishing version number. If the Program specifies a version number of this License which applies to it and "any later version", you have the option of following the terms and conditions either of that version or of any later version published by the Free Software Foundation. If the Program does not specify a version number of this License, you may choose any version ever published by the Free Software Foundation.

10. If you wish to incorporate parts of the Program into other free programs whose distribution conditions are different, write to the author to ask for permission. For software which is copyrighted by the Free Software Foundation, write to the Free Software Foundation; we sometimes make exceptions for this. Our decision will be guided by the two goals of preserving the free status of all derivatives of our free software and of promoting the sharing and reuse of software generally.

NO WARRANTY

11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.

12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.


Exceptions for localize of .NET 1.1 applications

Because it can not run the .NET 1.1 process in the .NET 2 domain, we must evade localization process in case that localizing program is writing in the .NET 1.1. Localizator can not build national assembly directly, but it create *.resx files of every assembly resource in a project directory.

How to do?

  1. You open your assembly written in the .NET 1.1. Translate all resources as well as it would be .NET 2.
  2. You suit resx to .NET 1.1.

    Because resx writer of .NET 2 create resx file in .NET 2 format, you must replace a some strings to .NET 1.1 format. Normally, resx writer save in this way:
     <data name="label1.Size" type="System.Drawing.Size, System.Drawing, Version=2.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
    But you must obtain this format:
     <data name="label1.Size" type="System.Drawing.Size, System.Drawing, Version=1.0.5000.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a">
    In table (see picture) you write list of all difference, which can occur in your assembly.
  3. Build your project. In info panel you can find this message:
    Run satellite assembly building from command line: LocBuild011.exe "<path>\project.txt"
    Follow this instruction and run LocBuild011.exe outside of Localizator environment. LocBuild011.exe is in the same directory as Localizator.


Main Program

Basic Principles

Before localization of each file you have to ensure you have necessary local support for source and target language. That means corresponding fonts and for target language also keyboard. If you want to edit source language texts you should have installed also keyboard for that language.

Functionality

List of Projects
Right top window contains list of opened projects. You can open so many files, how many your computer can manage. Before opening a file for localization, choose target language you will be translating to. During new file opening select a type of file you want to localize. List of types depends on modules you have available for localization.

Target Language
Left window contains list of languages available in your Windows. If you cannot find required language, it can be caused by one of these reasons: your version OS Windows does not support it or language national support is not installed. Before file opening always select correct target language. Generally you can open any number of files for one language or more instances of one file for different languages – so many, how many your computer can manage.

Dictionaries
Right bottom window contains list of currently opened dictionaries. Dictionary can be opened manually – again in dependence on set language – or during the project opening. Dictionaries, which are used by project, are opened automatically. Generally project or resource block can use many different dictionaries, one for each compact object. For example in executable programs you can use special dictionary for strings, other dictionary for dialogs, eventually for each dialog you can have independent dictionary and so on.

Favorite Projects
Language Localizator allows building lists of favorite projects. First of all it is necessary to create a project name. Then project can contain one or more localized files, which can be added to project. For each file choose target language and the way of localization for the case of silent localization.

Single projects can be opened for localization later or you can run whole project as a “silent” localization at the background.

Marking Lines As Translated
Some files contain texts, which must not be localized. It can cause the type of localized file or by careless way of programming (To the section for localization are put internal texts). That is why Language Localizator allows building list of such “dangerous” texts, which are automatically marked as translated, without any changes to them. File localization module can have its own set for marking lines as translated.

Ignored Properties
Some localized object can contain also names of items (component properties). Typical example can be forms. In this window you can enter list of names, which should be hidden from translator, because some of properties must not be translated. You can determine here, if the string is located at the beginning or somewhere inside the name of particular property and if it is active for further use. File localization module can have also here its own set of such properties.


Using strong name signing

If your main assembly uses strong naming, satellite assemblies must be signed with the same private key as the main assembly. If the public/private key pair does not match between the main and satellite assemblies, your resources will not be loaded. If you want sign yours assemblies, use *.pfx certificate rather than poor *.snk.

What to do:
Obtain your *.pfx certificate with the privacy key. However, you do not build app with this key, but normally without signature. Next you create your satellite assemblies with translations. Finally you add your digitally certificate as follows:

"[path]\Microsoft Visual Studio 8\SDK\v2.0\Bin\signtool.exe" sign /f yourcertificate.pfx /p yourpassword YourApp.exe
"[path]\Microsoft Visual Studio 8\SDK\v2.0\Bin\signtool.exe" sign /f yourcertificate.pfx /p yourpassword YourApp.resources.dll